<?php
    require_once __DIR__ . '/vendor/autoload.php';
    use ArUtil\ArUtil;

	include_once ('../includes/variables.php');
	DEFINE ('DB_HOST', $host);
	DEFINE ('DB_USER', $username);	 
	DEFINE ('DB_PASSWORD', $password);
	DEFINE ('DB_NAME', $databasename);
	DEFINE ('TABLE_NAME', "uniquewords");

    $mysqli = mysqli_connect(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME) or die (mysqli_error($conn)); 
    if ($mysqli->connect_errno) {
    	echo "Failed to connect to MySQL: " . $mysqli->connect_error;
    	exit();
    }
    
    $iscollate = ''; 
    $iscollate = ' COLLATE utf8_bin'; 
        
    //Run once UTF8 display & search related issues.
    $sSQL= 'SET CHARACTER SET utf8'; 
    
    
    mysqli_query($mysqli , $sSQL) or die ('Can\'t charset in DataBase'); 

    // Function for basic field validation (present and neither empty nor only white space
    function IsNullOrEmptyString($str){
        return (!isset($str) || trim($str) === '');
    }
    
    if (isset($_POST['queryNoun'])) {
        $input = $_POST['queryNoun'];
        $row = '';
        $input_as_user_entered = '';
        
        $input = trim($input , $character_mask = " \t\n\r\0\x0B");
        if(IsNullOrEmptyString($input)){
            echo "<a><li class='list-group-item'>No-results-found</li></a>";
            return;
        }
        $input_as_user_entered = $input;
        
        $diacritic = array('\u064b','\u064c','\u064d','\u064e','\u064f',
                            '\u0650','\u0651','\u0652','\u0653','\u0654','\u0655'
                            ,'\u0656','\u0657','\u0658','\u0659','\u065a','\u065b'
                            ,'\u065c','\u065d','\u065e','\u065f','\u0660');
        $newString = str_replace($diacritic, '', json_encode($input));
        $input = json_decode(str_replace('\u', '\u0652\u', $newString));
        $input_old = $input;
        $arQ =  ArUtil::query();
        $input = $arQ->regexpy($input);


        $query = "(SELECT uniqueword, meaning, id as uniquewordsid, 'unique' as uniquewords FROM uniquewords 
                  WHERE uniqueword = '$input_old') 
                  UNION (SELECT singular, meaning, id as nounid, 'noun' as noun FROM noun 
                          WHERE singular = '$input_old') 
                  UNION (SELECT hepast, meaning, id as sarfid, 'verb' as sarf FROM sarf 
                          WHERE hepast = '$input_old')
                  UNION(SELECT arabic, tamil, id as dictionaryid, 'dict' as dictionary FROM dictionary 
                  WHERE arabic = '$input_old')";

/*       $query .= "UNION(SELECT uniqueword, meaning, id as uniquewordsid, 'unique' as uniquewords 
                    FROM uniquewords WHERE uniqueword LIKE N'%$input%') 
                   UNION (SELECT singular, meaning, id as nounid, 'noun' as noun FROM noun 
                          WHERE singular LIKE N'%$input%') 
                   UNION (SELECT hepast, meaning, id as sarfid, 'verb' as sarf FROM sarf 
                          WHERE hepast LIKE N'%$input%') 
                   UNION (SELECT arabic, tamil, id as dictionaryid, 'dict' as dictionary FROM dictionary 
                          WHERE arabic LIKE N'%$input%')";
*/
        $query .= "UNION(SELECT uniqueword, meaning, id as uniquewordsid, 'unique' as uniquewords FROM uniquewords 
                  WHERE uniqueword  REGEXP '$input') 
                  UNION (SELECT singular, meaning, id as nounid, 'noun' as noun FROM noun 
                          WHERE singular  REGEXP '$input') 
                  UNION (SELECT hepast, meaning, id as sarfid, 'verb' as sarf FROM sarf 
                          WHERE hepast  REGEXP '$input') 
                  UNION(SELECT arabic, tamil, id as dictionaryid, 'dict' as dictionary FROM dictionary 
                  WHERE arabic REGEXP '$input')
                  
                  LIMIT 200";


        //Use simple usual search when needed *DoNot delete*
        $simplesearch = false; 
        if ($simplesearch == true){
            $input = $input_as_user_entered;
            $query = "(SELECT uniqueword, meaning, id as uniquewordsid, 'unique' as uniquewords FROM uniquewords WHERE uniqueword LIKE N'%$input%') 
                    UNION (SELECT singular, meaning, id as nounid, 'noun' as noun FROM noun WHERE singular LIKE N'%$input%') 
                    UNION (SELECT hepast, meaning, id as sarfid, 'verb' as sarf FROM sarf WHERE hepast LIKE N'%$input%') 
                    UNION (SELECT arabic, tamil, id as dictionaryid, 'dict' as dictionary FROM dictionary WHERE arabic LIKE N'%$input%') LIMIT 200";
        }
    
        $result = $mysqli->query($query);
        
        echo "<table class='table'> <tbody>";    

    	if ($result->num_rows > 0) {
    	    
    		while ($row = $result->fetch_assoc()) {
        		    if ($result->num_rows <= 200) {
                     echo "<tr onmouseover='uniqueWord(". $row["uniquewordsid"] .")' >
        		           <td >
        		           <li class='list-group-item' onclick='uniqueWord(". $row["uniquewordsid"] .")' id='uniquename_".$row["uniquewordsid"]."'>".$row['uniqueword']."</li>
        		           </td> 
        		           <td class='classid' id='uniqueid'>".$row['uniquewordsid']."</td> 
        		           <td>".$row['uniquewords']."</td> 
        		           <td class='class-meaning'>".$row['meaning']."</td> 
        		           </tr>";
        		        /*
                           "<tr>
        		           <td id='nounid'>".$row['nounid']."</td> 
        		           <td ><li class='list-group-item' id='singular'>".$row['singular']."</td> 
        		           <td>".$row['noun']."</td> 
        		           <td class='class-meaning'>".$row['meaning']."</td> 
        		           </tr>";
        		          
        		           "<tr>
        		           <td id='sarfid'>".$row['sarfid']."</td> 
        		           <td ><li class='list-group-item' id='hepast'>".$row['hepast']."</td> 
        		           <td>".$row['sarf']."</td> 
        		           <td class='class-meaning'>".$row['meaning']."</td> 
        		           </tr>";
        		          
        		           
        		           "<td id='dictid'>".$row['dictionaryid']."</td> 
        		           <td ><li class='list-group-item' id='arabic'>".$row['arabic']."</td> 
        		           <td>".$row['dictionary']."</td> 
        		           <td class='class-meaning'>".$row['meaning']."</td> 
        		           </tr>";
                        */   
        		    }
        		   
    		}
    			
    	} else {
            echo "<a><li class='list-group-item'>No-results-found</li></a>";
    	}
    	 echo "</tbody>
                    </table>  ";
    
    }


    // Insert and Update Date
    if (isset($_POST['submit'])) {
            $data = '';
    		$uniqueword_input = $_POST['uniqueword'];
    		$meaning_input = $_POST['meaning'];
    		$isdone = (isset($_POST['isdone']) ? 1 : 0);
    		
    		$word1 = $_POST['word1'];
    		$word2 = $_POST['word2'];
    		$word3 = $_POST['word3'];
    		$word4 = $_POST['word4'];
    		$word5 = $_POST['word5'];
    	
            $uniqueword = trim($uniqueword_input , $character_mask = " \t\n\r\0\x0B");
            $meaning = trim($meaning_input , $character_mask = " \t\n\r\0\x0B");
            
            if(IsNullOrEmptyString($uniqueword)){
                $data = 'Failed. Unique Word not saved. It is empty or null.';
    			echo json_encode($data);
    			header("Location: index.php?msg=" . $data); 
    			return;
            }

            date_default_timezone_set("Asia/Calcutta"); //("Asia/Kolkata")
            $currenttime = date("Y-m-d H:i:s");

            $query = "INSERT INTO ".TABLE_NAME."(uniqueword, meaning, word1id, word2id, word3id, word4id, word5id, done, modified) 
    		VALUES(N'$uniqueword', N'$meaning',  '$word1', '$word2', '$word3',  '$word4', '$word5', '$isdone', '$currenttime')";
    
    		$result = $mysqli->query($query);
            //$result = mysqli_query($result, $mysqli) or trigger_error("Query Failed! SQL: $sql - Error: ".mysqli_error(), E_USER_ERROR);
            
    		if ($result) {
    			$data = 'New Unique Word saved successfully ('. $uniqueword .')';
    			echo json_encode($data);
    			header("Location: index.php?msg=" . $data);
    		} else {
    			$data = 'Failed. Unique Word not saved' ." (".($mysqli -> error).")";
    			echo json_encode($data);
    			header("Location: index.php?msg=" . $data);
    		}
    	}
    
    
    
    

?>